﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private ASCalendarAdvanced1 As ASCalendarAdvanced
	Private Label1 As Label
End Sub

Public Sub Initialize
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("frm_main")
	B4XPages.SetTitle(Me,"AS CalendarAdvanced Example")

	'ASCalendarAdvanced1.WeekNameShort = ASCalendarAdvanced1.CreateASCalendarAdvanced_WeekNameShort("Mon","Tue","Wed","Thu","Fri","Sat","Sun")
	'ASCalendarAdvanced1.MonthNameShort = ASCalendarAdvanced1.CreateASCalendarAdvanced_MonthNameShort("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sept","Oct","Nov","Dec")
	
	ASCalendarAdvanced1.MonthNameShort.May = "May" 'needs a UpdateBody
	ASCalendarAdvanced1.WeekNameShort.Friday = "Friday" 'needs a UpdateHeader
	
	ASCalendarAdvanced1.UpdateBody
	ASCalendarAdvanced1.UpdateHeader
	
	ASCalendarAdvanced1.ShowFirstWeekOfMonthInFirstRow = False
	'Call this to Build the calendar, unfortunately this is needed, otherwise runtime errors will occur
	'Call this after you set all properties you want
	ASCalendarAdvanced1.CreateCalendar
	
	'Sleep(2000)
	Dim p As Period
	p.Days = 1
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_ARGB(255,221, 95, 96))'red

	p.Days = -1
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_ARGB(255,45, 136, 121))'green
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_ARGB(255,221, 95, 96))'red
	
	
	p.Days = 3
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_ARGB(255,45, 136, 121))'green
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_ARGB(255,221, 95, 96))'red
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_ARGB(255,73, 98, 164))'blue
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_ARGB(255,141, 68, 173))'purple
	
	p.Days = 2
	ASCalendarAdvanced1.AddSpecialDay(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_Magenta,"birthday")
	
	p.Days = 0
	p.Months = 3
	ASCalendarAdvanced1.AddAppointmentType1(DateUtils.AddPeriod(DateTime.Now,p),xui.Color_Yellow)
	

	SetDateTimeLocale(GetPreferredLanguage)
	DateTime.DateFormat = "EEEE dd MMMM"
	Label1.Text = DateTime.Date(DateTime.Now)
	'SetDateTimeLocale("EN-en")
End Sub


Sub SetDateTimeLocale (locale As String)
	Dim loc As NativeObject
	loc = loc.Initialize("NSLocale").RunMethod("localeWithLocaleIdentifier:", Array(locale))
	Dim no As NativeObject = DateTime
	no.GetField("dateFormat").SetField("locale", loc)
	no.GetField("timeFormat").SetField("locale", loc)
End Sub

Sub GetPreferredLanguage As String
	Dim no As NativeObject
	Return no.Initialize("NSLocale").RunMethod("preferredLanguages", Null).RunMethod("objectAtIndex:", Array(0)).AsString
End Sub


Sub ASCalendarAdvanced1_HeightChanged(Height As Float)
	Log("HeightChanged: " & Height)
End Sub

Sub ASCalendarAdvanced1_SelectedDateChanged(Date As Long)
	Log("SelectedDateChanged: " & DateUtils.TicksToString(Date))
	B4XPages.SetTitle(Me,"AS CalendarAdvanced Example " & DateTime.GetDayOfMonth(Date) & "." &  DateTime.GetMonth(Date) & "." & DateTime.GetYear(Date))
End Sub

Sub ASCalendarAdvanced1_VisibleRangeChanged(StartDate As Long,EndDate As Long)
	Log("VisibleRangeChanged StartDate: " & DateUtils.TicksToString(StartDate) & " EndDate: " & DateUtils.TicksToString(EndDate))
	
	Dim sundays As List = ASCalendarAdvanced1.GetDaysBetween2Dates(StartDate,EndDate, 1)
	For Each s As Long In sundays
		ASCalendarAdvanced1.AddSpecialDay(s,xui.Color_ARGB(255,221, 95, 96),"official_holiday")
	Next
	ASCalendarAdvanced1.CommitSpecialDays
End Sub



#If B4J
Private Sub xlbl_back2currentday_MouseClicked (EventData As MouseEvent)
	ASCalendarAdvanced1.Back2CurrentDate
End Sub
Sub xlbl_next_MouseClicked (EventData As MouseEvent)
	ASCalendarAdvanced1.NextWeek
End Sub

Sub xlbl_back_MouseClicked (EventData As MouseEvent)
	ASCalendarAdvanced1.PreviousWeek
End Sub
#Else
Sub xlbl_back2currentday_Click
	ASCalendarAdvanced1.Back2CurrentDate
End Sub
Sub xlbl_next_Click
	ASCalendarAdvanced1.NextWeek
End Sub

Sub xlbl_back_Click
	ASCalendarAdvanced1.PreviousWeek
End Sub
#End If